﻿#region Usings
    using System;
    using System.Collections.Generic;

    using Styx;
    using Styx.Common;
    using Styx.WoWInternals.WoWObjects;
#endregion

#region Bindings
    using D = Arcanum.Core.Helpers.Debug;
#endregion

namespace Arcanum.Core.Managers
{
    class Talent_Manager
    {
        private static string talentTier1 { get; set; }
        private static string talentTier2 { get; set; }
        private static string talentTier3 { get; set; }
        private static string talentTier4 { get; set; }
        private static string talentTier5 { get; set; }
        private static string talentTier6 { get; set; }
        private static string talentTier7 { get; set; }

        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        #region Fetch and Update active Talents

        public static void updateTalents()
        {
            setTalents();
        }

        private static string getTalents(int talent)
        {
            return Me.GetLearnedTalent(talent).Name;
        }

        private static string fetchTalents(int position)
        {
            try
            {
                D.diagnosticLog("Talent on tier " + (position + 1) + ": " + getTalents(position));
                return getTalents(position);
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in Talent Tier: " + error);
                return "No talent on tier " + (position + 1);
            }
        }

        #endregion

        #region Setting Talents

        #region Bools for Talents

        #region General
        // TIER 1 Talents
        public static bool iceFloes { get; set; }
        public static bool blazingSpeed { get; set; }
        public static bool evanesce { get; set; }

        // TIER 2 Talents
        public static bool alterTime { get; set; }
        public static bool iceBarrier { get; set; }
        public static bool flameglow { get; set; }

        // TIER 3 Talents
        public static bool ringOfFrost { get; set; }
        public static bool iceWard { get; set; }
        public static bool frostjaw { get; set; }

        // TIER 4 Talents
        public static bool greaterInvisibility { get; set; }
        public static bool coldSnap { get; set; }
        public static bool cauterize { get; set; }

        // TIER 6 Talents
        public static bool mirrorImage { get; set; }
        public static bool runeOfPower { get; set; }
        public static bool incantersFlow { get; set; }
        #endregion

        #region Arcane

        // TIER 5 Talents
        public static bool netherTempest { get; set; }
        public static bool supernova { get; set; }
        public static bool unstableMagic { get; set; }

        // TIER 7 Talents
        public static bool overpowered { get; set; }
        public static bool prismaticCrystal { get; set; }
        public static bool arcaneOrb { get; set; }

        #endregion

        #region Frost

        // TIER 5 Talents
        public static bool frostBomb { get; set; }
        public static bool iceNova { get; set; }

        // TIER 7 Talents
        public static bool thermalVoid { get; set; }
        public static bool cometStorm { get; set; }

        #endregion

        #endregion

        public static bool setTalents()
        {
            talentTier1 = fetchTalents(0);
            talentTier2 = fetchTalents(1);
            talentTier3 = fetchTalents(2);
            talentTier4 = fetchTalents(3);
            talentTier5 = fetchTalents(4);
            talentTier6 = fetchTalents(5);
            talentTier7 = fetchTalents(6);

            #region General

                #region Tier 1 Talents

            try
            {
                if (talentTier1 == "Ice Floes")
                { iceFloes = true; blazingSpeed = false; evanesce = false; }
                if (talentTier1 == "Blazing Speed")
                { iceFloes = false; blazingSpeed = true; evanesce = false; }
                if (talentTier1 == "Evanesce")
                { iceFloes = false; blazingSpeed = false; evanesce = true; }
            }
            catch (Exception error)
            {
                iceFloes = false; blazingSpeed = false; evanesce = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 1: " + error);
            }

            #endregion

                #region Tier 2 Talents

            try
            {
                if (talentTier2 == "Alter Time")
                { alterTime = true; iceBarrier = false; flameglow = false; }
                if (talentTier2 == "Ice Barrier")
                { alterTime = false; iceBarrier = true; flameglow = false; }
                if (talentTier2 == "Flameglow")
                { alterTime = false; iceBarrier = false; flameglow = true; }
            }
            catch (Exception error)
            {
                alterTime = false; iceBarrier = false; flameglow = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 2: " + error);
            }

            #endregion

                #region Tier 3 Talents

            try
            {
                if (talentTier3 == "Ring of Frost")
                { ringOfFrost = true; iceWard = false; frostjaw = false; }
                if (talentTier3 == "Ice Ward")
                { ringOfFrost = false; iceWard = true; frostjaw = false; }
                if (talentTier3 == "Frostjaw")
                { ringOfFrost = false; iceWard = false; frostjaw = true; }
            }
            catch (Exception error)
            {
                ringOfFrost = false; iceWard = false; frostjaw = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 3: " + error);
            }

            #endregion

                #region Tier 4 Talents

            try
            {
                if (talentTier4 == "Greater Invisibility")
                { greaterInvisibility = true; coldSnap = false; cauterize = false; }
                if (talentTier4 == "Cold Snap")
                { greaterInvisibility = false; coldSnap = true; cauterize = false; }
                if (talentTier4 == "Cauterize")
                { greaterInvisibility = false; coldSnap = false; cauterize = true; }
            }
            catch (Exception error)
            {
                greaterInvisibility = false; coldSnap = false; cauterize = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 4: " + error);
            }

            #endregion

                #region Tier 6 Talents

            try
            {
                if (talentTier6 == "Mirror Image")
                { mirrorImage = true; runeOfPower = false; incantersFlow = false; }
                if (talentTier6 == "Rune of Power")
                { mirrorImage = false; runeOfPower = true; incantersFlow = false; }
                if (talentTier6 == "Incanter's Flow")
                { mirrorImage = false; runeOfPower = false; incantersFlow = true; }
            }
            catch (Exception error)
            {
                mirrorImage = false; runeOfPower = false; incantersFlow = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 6: " + error);
            }

            #endregion

            #endregion

            #region Arcane

                #region Tier 5 Talents

            try
            {
                if (talentTier5 == "Nether Tempest")
                { netherTempest = true; supernova = false; unstableMagic = false; }
                if (talentTier5 == "Supernova")
                { netherTempest = false; supernova = true; unstableMagic = false; }
                if (talentTier5 == "Unstable Magic")
                { netherTempest = false; supernova = false; unstableMagic = true; }
            }
            catch (Exception error)
            {
                netherTempest = false; supernova = false; unstableMagic = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 5: " + error);
            }

            #endregion

                #region Tier 7 Talents

            try
            {
                if (talentTier7 == "Overpowered")
                { overpowered = true; prismaticCrystal = false; arcaneOrb = false; }
                if (talentTier7 == "Prismatic Crystal")
                { overpowered = false; prismaticCrystal = true; arcaneOrb = false; }
                if (talentTier7 == "Arcane Orb")
                { overpowered = false; prismaticCrystal = false; arcaneOrb = true; }
            }
            catch (Exception error)
            {
                overpowered = false; prismaticCrystal = false; arcaneOrb = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 7: " + error);
            }

            #endregion

            #endregion

            #region Fire

            #endregion

            #region Frost

                #region Tier 5 Talents

            try
            {
                if (talentTier5 == "Frost Bomb")
                { frostBomb = true; iceNova = false; unstableMagic = false; }
                if (talentTier5 == "Ice Nova")
                { frostBomb = false; iceNova = true; unstableMagic = false; }
                if (talentTier5 == "Unstable Magic")
                { frostBomb = false; iceNova = false; unstableMagic = true; }
            }
            catch (Exception error)
            {
                netherTempest = false; supernova = false; unstableMagic = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 5: " + error);
            }

            #endregion

                #region Tier 7 Talents

            try
            {
                if (talentTier7 == "Thermal Void")
                { thermalVoid = true; prismaticCrystal = false; cometStorm = false; }
                if (talentTier7 == "Prismatic Crystal")
                { thermalVoid = false; prismaticCrystal = true; cometStorm = false; }
                if (talentTier7 == "Comet Storm")
                { thermalVoid = false; prismaticCrystal = false; cometStorm = true; }
            }
            catch (Exception error)
            {
                overpowered = false; prismaticCrystal = false; arcaneOrb = false;
                D.diagnosticLog("Exception thrown in setTalents Tier 7: " + error);
            }

            #endregion

            #endregion

            return true;
        }

        #endregion

    }
}
