﻿#region Usings
    using System;
    using System.Threading.Tasks;
    using System.Linq;

    using Styx;
    using Styx.CommonBot;
    using Styx.WoWInternals.WoWObjects;
    using Styx.WoWInternals;
    using Styx.CommonBot.Coroutines;
    using Buddy.Coroutines;
#endregion

#region Bindings
    using U = Arcanum.Core.Unit;
    using SB = Arcanum.Core.Helpers.Spell_Book;
    using D = Arcanum.Core.Helpers.Debug;
#endregion

namespace Arcanum.Core
{
    static class Spell
    {
        public delegate WoWUnit unitSelectionDelegate(object Context);
        public delegate T Selection<out T>(object Context);
        public static int lastSpellCast;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region Cast Methods
        public static async Task<bool> spellCast(int spell, bool reqs)
        {
            try
            {
                if (!U.isUnitValid(currentTarget))
                    return false;
                if (!Me.CurrentTarget.InLineOfSight)
                    return false;
                if (spell == SB.spellArcaneExplosion)
                { }
                else
                {
                    if (!Me.IsFacing(currentTarget))
                        return false;
                }
                //if (Me.Stunned)
                //    return false;
                if (Me.Silenced)
                    return false;
                if (!reqs)
                    return false;
                if (!SpellManager.CanCast(WoWSpell.FromId(spell), currentTarget, false, false, false))
                    return false;
                if (!SpellManager.Cast(spell, currentTarget))
                    return false;
                lastSpellCast = spell;
                D.diagnosticLog("Casting " + WoWSpell.FromId(spell).Name + " on target " + currentTarget.SafeName);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception thrown in spellCast: " + error);
                return false;
            }
        }

        public static async Task<bool> spellDrop(int spell, bool reqs)
        {
            try
            {
                if (!U.isUnitValid(currentTarget))
                    return false;
                if (!reqs)
                    return false;
                if (!SpellManager.CanCast(WoWSpell.FromId(spell), currentTarget, false, false, false))
                    return false;
                if (!SpellManager.Cast(spell, currentTarget))
                    return false;
                if (!await Coroutine.Wait(10, () => Me.CurrentPendingCursorSpell != null))
                {
                    return false;
                }
                SpellManager.ClickRemoteLocation(currentTarget.Location.RayCast(Me.Rotation + Styx.Helpers.WoWMathHelper.DegreesToRadians(150), 4f));
                lastSpellCast = spell;
                D.diagnosticLog("Dropping " + WoWSpell.FromId(spell).Name + " near target " + currentTarget.SafeName);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in spellDrop: " + error);
                return false;
            }
        }

        public static async Task<bool> spellDropRoPOnMe(int spell, bool reqs)
        {
            try
            {
                if (Me.HasAura(SB.auraRuneOfPower))
                    return false;
                if (!U.isUnitValid(currentTarget))
                    return false;
                if (!reqs)
                    return false;
                if (Me.IsMoving)
                    return false;
                if (!SpellManager.CanCast(WoWSpell.FromId(spell), currentTarget, false, false, false))
                    return false;
                if (!SpellManager.Cast(spell, currentTarget))
                    return false;
                if (!await Coroutine.Wait(10, () => Me.CurrentPendingCursorSpell != null))
                {
                    return false;
                }
                SpellManager.ClickRemoteLocation(Me.Location);
                lastSpellCast = spell;
                D.diagnosticLog("Casting " + WoWSpell.FromId(spell).Name + " on me ");
                await CommonCoroutines.SleepForRandomReactionTime();
                return true;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in spellDropRoPOnMe: " + error);
                return false;
            }
        }

        public static async Task<bool> Buff(int spell, bool reqs)
        {
            try
            {
                if (!reqs)
                    return false;
                if (!SpellManager.CanCast(WoWSpell.FromId(spell), Me, false, false, false))
                    return false;
                if (!SpellManager.Cast(spell, Me))
                    return false;
                lastSpellCast = spell;
                D.diagnosticLog("Buffing " + WoWSpell.FromId(spell).Name);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in Buff: " + error);
                return false;
            }

        }

        public static async Task<bool> castPetSpell(bool reqs)
        {
            if (!reqs)
                return false;
            var pet = Me.PetSpells.FirstOrDefault(x => x.Spell.Name == "Water Jet");
            if (pet != null && pet.Spell.CanCast)
            {
                pet.Spell.Cast();
            }
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        #endregion

        #region Cooldown Detection
        public static double cooldownTimeLeft(this int Spell)
        {
            try
            {
                SpellFindResults Results;
                return SpellManager.FindSpell(Spell, out Results) ? (Results.Override != null ? Results.Override.CooldownTimeLeft.TotalMilliseconds : Results.Original.CooldownTimeLeft.TotalMilliseconds) : 9999;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in cooldownTimeLeft: " + error);
                return 9999;
            }
        }
        #endregion

        #region Spell Charges
        public static int spellCharges(int spell)
        {
            try
            {
                int charges;
                charges = Lua.GetReturnVal<int>("return GetSpellCharges(" + spell + ")", 0);
                return charges;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in spellCharges: " + error);
                return 9999;
            }
        }
        #endregion

        #region Use potion/flask/item

        public static async Task<bool> usePotion(int itemid, bool reqs)
        {
            try
            {
                var whichitem = StyxWoW.Me.Inventory.PhysicalItems.FirstOrDefault(i => i.Entry == itemid);
                if (!reqs)
                return false;
                if (!whichitem.Usable)
                    return false;
                if (whichitem == null)
                    return false;
                if (whichitem != null && whichitem.CooldownTimeLeft.TotalSeconds <= 0)
                    whichitem.UseContainerItem();
                D.diagnosticLog("Using potion/flask or HS");
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in usePotion: " + error);
                return false;
            }
        }

        #endregion

        #region Group or Raid buffing

        public static bool needBrilliance()
        {
            try
            {
                var t = U.PartyMembers.Where(p => p.IsAlive
                     && p.Distance <= 40
                     && p.InLineOfSight
                     && !p.HasAura(SB.spellArcBrilliance)).FirstOrDefault();
                return t != null ? true : false;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in needBrilliance: " + error);
                return false;
            }
        }

        #endregion
    }
}
