﻿#region Usings
    using System;
    using System.Windows.Media;

    using Styx;
    using Styx.Common;
    using Styx.WoWInternals.WoWObjects;
    using Styx.CommonBot.Routines;
    using CommonBehaviors.Actions;
    using Styx.TreeSharp;
    using Styx.CommonBot;
    using Styx.WoWInternals;

#endregion

#region Bindings
    using HKM = Arcanum.Core.Managers.Hotkey_Manager;
    using U = Arcanum.Core.Unit;
    using SB = Arcanum.Core.Helpers.Spell_Book;
    using R = Arcanum.Rotation.Rotation;
    using S = Arcanum.Core.Spell;
    using D = Arcanum.Core.Helpers.Debug;
    using TM = Arcanum.Core.Managers.Talent_Manager;
#endregion


namespace Arcanum
{
    public class Main : CombatRoutine
    {
        private static readonly Version version = new Version(2, 0);
        public override string Name { get { return "Arcanum - Mage Combat Rotation v" + version; } }
        public override WoWClass Class { get { return WoWClass.Mage; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        public override bool WantButton { get { return true; } }
        public override void OnButtonPress() { Logging.Write(Colors.OrangeRed, "Coming really soon!"); }
        public override void ShutDown() { HKM.removeHotkeys(); }

        #region Startup & Hot Key registration
        public override void Initialize()
        {
            #region LUA
            Lua.Events.AttachEvent("PLAYER_TALENT_UPDATE", delegate
            {
                TM.updateTalents();
            }
            );
            Lua.Events.AttachEvent("PLAYER_EQUIPMENT_CHANGED", delegate
            {
                U.checkGear();
            });
            Lua.Events.AttachEvent("WEAR_EQUIPMENT_SET", delegate
            {
                U.checkGear();
            });
            #endregion

            Logging.Write(Colors.CadetBlue, "Arcanum - Mage Combat Rotation");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.Orange, "Designed for the Enyo botbase");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.Orange, "Current Version: v" + version + " - by Stampe");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.BlueViolet, "Updating Talents from " + Me.Name);

            TM.setTalents();
            HKM.registerHotKeys();
            U.checkGear();
        }
     
        #endregion

        #region Implement - Pre/Combat- Buffing and Behaviors

        public override Composite PreCombatBuffBehavior { get { return new ActionRunCoroutine(ctx => R.preCombatBuffing()); } }

        public override Composite CombatBuffBehavior { get { return new ActionRunCoroutine(ctx => R.combatBuffing()); } }

        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => R.rotationSelector()); } }

        #endregion

        #region Pulse and Trigger
        public override void Pulse()
        {
            if (!StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (!Me.Combat)
                return;
            U.Cache();
            U.enemyAnnex(40f);
            U.AoEenemyAnnex(12f);
            U.activeEnemyAnnex(40f);

            try
            {
                if ((Me.ManaPercent > 92 && Me.IsChanneling && Me.ChanneledCastingSpellId == SB.spellEvocation) || (Me.HasAura(SB.auraRuneOfPower) && Me.IsCasting && Me.CastingSpellId == SB.spellRuneofPower))
                {
                    SpellManager.StopCasting();
                }
                if (!currentTarget.CanInterruptCurrentSpellCast && Me.IsCasting && Me.CastingSpellId == SB.spellFrostjaw)
                {
                    SpellManager.StopCasting();
                }
                if (!SpellManager.CanCast(SB.spellPrismCrystal) && (S.cooldownTimeLeft(SB.spellPrismCrystal) <= 79000) && Me.CurrentTarget.SafeName == "Prismatic Crystal")
                {
                    Me.TargetLastTarget();
                }
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in Main Pulse: " + error);
            }
        }
        #endregion   
    }
}
