﻿#region Usings
    using System.Threading.Tasks;

    using Styx;
    using Styx.CommonBot;
    using Styx.CommonBot.Coroutines;
    using Styx.WoWInternals.WoWObjects;
#endregion

#region Bindings
    using S = Arcanum.Core.Spell;
    using SB = Arcanum.Core.Helpers.Spell_Book;
    using U = Arcanum.Core.Unit;
    using TM = Arcanum.Core.Managers.Talent_Manager;
#endregion

namespace Arcanum.Rotation.Arcane
{
    class Burn
    {
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        #region Burn Rotation

        public static async Task<bool> BurnSingleTarget()
        {

            //counterspell,if=target.debuff.casting.react
            if (SpellManager.CanCast(SB.spellCounterspell) && currentTarget.CanInterruptCurrentSpellCast && (currentTarget.IsCasting || currentTarget.IsChanneling))
            {
                await CommonCoroutines.SleepForRandomReactionTime();
                return await S.spellCast(SB.spellCounterspell, currentTarget.CanInterruptCurrentSpellCast);
            }

            if (TM.frostjaw == true && !SpellManager.CanCast(SB.spellCounterspell) && currentTarget.Distance <= 30 && currentTarget.CanInterruptCurrentSpellCast && (currentTarget.IsCasting || currentTarget.IsChanneling))
            {
                await CommonCoroutines.SleepForRandomReactionTime();
                return await S.spellCast(SB.spellFrostjaw, TM.frostjaw == true && currentTarget.CanInterruptCurrentSpellCast);
            }

            if (await S.spellDrop(SB.spellRingofFrost, TM.ringOfFrost == true && (U.activeCount >= 3 && currentTarget.Distance <= 30))) return true;

            //arcane_power
            if (await S.Buff(SB.spellArcanePower, SpellManager.CanCast(SB.spellArcanePower) && (currentTarget.HealthPercent > 10 || currentTarget.IsBoss || currentTarget.Name == "Prismatic Crystal"))) return true;

            ////arcane_missiles,if=buff.arcane_missiles.react=3 
            if (await S.spellCast(SB.spellArcaneMissile, U.stacksArcaneMissile == 3)) return true;

            //arcane_missiles,if=set_bonus.tier17_4pc&buff.arcane_instability.react&buff.arcane_instability.remains<action.arcane_blast.execute_time //Arc insta = buffen från t17 4p!!
            if (await S.spellCast(SB.spellArcaneMissile, Me.HasAura(SB.auraArcaneInstability))) return true;

            ////supernova,if=time_to_die<8|charges=2  /// !!! GÖR EN CHECK FÖR CHARGES PÅ SPELLS!!!!!
            if (await S.spellCast(SB.spellSupernova, TM.supernova == true && !Me.HasAura(SB.spellIceFloes) && (currentTarget.HealthPercent < 8 || S.spellCharges(SB.spellSupernova) == 2))) return true;

            //nether_tempest,cycle_targets=1,if=target!=prismatic_crystal&buff.arcane_charge.stack=4&(active_dot.nether_tempest=0|(ticking&remains<3.6))
            if (await S.spellCast(SB.spellNetherTempest, TM.netherTempest == true && !Me.HasAura(SB.spellIceFloes) && U.auraStacks(currentTarget, SB.spellNetherTempest) == 0 && U.stacksArcaneCharge == 4 && U.auraTimeLeft(currentTarget, SB.spellNetherTempest) < 3 )) return true;

            ////arcane_orb,if=buff.arcane_charge.stack<4
            if (await S.spellCast(SB.spellArcaneOrb, TM.arcaneOrb == true && !Me.HasAura(SB.spellIceFloes) && U.stacksArcaneCharge < 4)) return true;

            ////arcane_barrage,if=talent.arcane_orb.enabled&active_enemies>=3&buff.arcane_charge.stack=4&(cooldown.arcane_orb.remains<gcd|prev_gcd.arcane_orb)
            if (await S.spellCast(SB.spellArcaneBarrage, TM.arcaneOrb == true && !Me.HasAura(SB.spellIceFloes) && U.activeCount >= 3 && U.stacksArcaneCharge == 4 && S.cooldownTimeLeft(SB.spellArcaneOrb) < 2 || S.lastSpellCast == SB.spellArcaneOrb)) return true;

            ////presence_of_mind,if=mana.pct>96
            if (await S.Buff(SB.spellPOM, Me.ManaPercent > 96)) return true;

            ////arcane_blast,if=buff.arcane_charge.stack=4&mana.pct>93
            if (await S.spellCast(SB.spellArcaneBlast, U.stacksArcaneCharge == 4 && Me.ManaPercent > 93)) return true;

            ////arcane_missiles,if=buff.arcane_charge.stack=4&(mana.pct>70|!cooldown.evocation.up)
            if (await S.spellCast(SB.spellArcaneMissile, U.stacksArcaneCharge == 4 && (Me.ManaPercent > 70 || !SpellManager.CanCast(SB.spellEvocation)))) return true;

            ////supernova,if=mana.pct>70&mana.pct<96
            if (await S.spellCast(SB.spellSupernova, TM.supernova == true && !Me.HasAura(SB.spellIceFloes) && (Me.ManaPercent > 70 && Me.ManaPercent < 96))) return true;

            ////evocation
            if (await S.spellCast(SB.spellEvocation, Me.ManaPercent <= 50)) return true;

            ////presence_of_mind,if=!talent.prismatic_crystal.enabled|!cooldown.prismatic_crystal.up
            if (await S.Buff(SB.spellPOM, TM.prismaticCrystal == false || !SpellManager.CanCast(SB.spellPrismCrystal))) return true;

            //arcane_blast
            if (await S.spellCast(SB.spellArcaneBlast, true)) return true;

            return true;
        }
        #endregion
    }
}
