﻿#region Usings
    using System.Threading.Tasks;

    using Styx;
    using Styx.CommonBot;
    using Styx.CommonBot.Coroutines;
    using Styx.WoWInternals.WoWObjects;
#endregion

#region Bindings
using S = Arcanum.Core.Spell;
using SB = Arcanum.Core.Helpers.Spell_Book;
using U = Arcanum.Core.Unit;
using TM = Arcanum.Core.Managers.Talent_Manager;
#endregion

namespace Arcanum.Rotation.Arcane
{
    class Conserve
    {
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        #region Conserve Rotation

        public static async Task<bool> ConserveSingleTarget()
        {

            //counterspell,if=target.debuff.casting.react
            if (SpellManager.CanCast(SB.spellCounterspell) && currentTarget.CanInterruptCurrentSpellCast && (currentTarget.IsCasting || currentTarget.IsChanneling))
            {
                await CommonCoroutines.SleepForRandomReactionTime();
                return await S.spellCast(SB.spellCounterspell, currentTarget.CanInterruptCurrentSpellCast);
            }

            if (TM.frostjaw == true && !SpellManager.CanCast(SB.spellCounterspell) && currentTarget.Distance <= 30 && currentTarget.CanInterruptCurrentSpellCast && (currentTarget.IsCasting || currentTarget.IsChanneling))
            {
                await CommonCoroutines.SleepForRandomReactionTime();
                return await S.spellCast(SB.spellFrostjaw, currentTarget.CanInterruptCurrentSpellCast);
            }
         
            if (await S.spellDrop(SB.spellRingofFrost, TM.ringOfFrost == true && (U.activeCount >= 3 && currentTarget.Distance <= 30))) return true;
            
            //arcane_power,if=time_to_die<30|(buff.arcane_charge.stack=4&(!talent.prismatic_crystal.enabled|cooldown.prismatic_crystal.remains>15))
            if (await S.Buff(SB.spellArcanePower, currentTarget.HealthPercent < 30 || U.stacksArcaneCharge == 4 && (TM.prismaticCrystal == false || S.cooldownTimeLeft(SB.spellPrismCrystal) > 15000))) return true;

            //arcane_missiles,if=buff.arcane_missiles.react=3|(talent.overpowered.enabled&buff.arcane_power.up&buff.arcane_power.remains<action.arcane_blast.execute_time)
            if (await S.spellCast(SB.spellArcaneMissile, U.stacksArcaneMissile == 3 || (TM.overpowered == true && Me.HasAura(SB.spellArcanePower)))) return true;

            //arcane_missiles,if=set_bonus.tier17_4pc&buff.arcane_instability.react&buff.arcane_instability.remains<action.arcane_blast.execute_time
            if (await S.spellCast(SB.spellArcaneMissile, Me.HasAura(SB.auraArcaneInstability))) return true;

            //nether_tempest,cycle_targets=1,if=target!=prismatic_crystal&buff.arcane_charge.stack=4&(active_dot.nether_tempest=0|(ticking&remains<3.6))
            if (await S.spellCast(SB.spellNetherTempest, TM.netherTempest == true && !Me.HasAura(SB.spellIceFloes) && U.stacksArcaneCharge == 4 && (U.auraStacks(currentTarget, SB.spellNetherTempest) == 0 || U.auraTimeLeft(currentTarget, SB.spellNetherTempest) < 3))) return true;

            //supernova,if=time_to_die<8|(charges=2&(buff.arcane_power.up|!cooldown.arcane_power.up)&(!talent.prismatic_crystal.enabled|cooldown.prismatic_crystal.remains>8))
            if (await S.spellCast(SB.spellSupernova, TM.supernova == true && !Me.HasAura(SB.spellIceFloes) && (currentTarget.HealthPercent < 8 || S.spellCharges(SB.spellSupernova) == 2 && (Me.HasAura(SB.spellArcanePower) || SpellManager.CanCast(SB.spellArcanePower)) && (TM.prismaticCrystal == false || S.cooldownTimeLeft(SB.spellPrismCrystal) > 8000)))) return true;

            //arcane_orb,if=buff.arcane_charge.stack<2
            if (await S.spellCast(SB.spellArcaneOrb, TM.arcaneOrb == true && !Me.HasAura(SB.spellIceFloes) && U.stacksArcaneCharge < 2)) return true;

            //presence_of_mind,if=mana.pct>96&(!talent.prismatic_crystal.enabled|!cooldown.prismatic_crystal.up)
            if (await S.Buff(SB.spellPOM, Me.ManaPercent > 96 && (TM.prismaticCrystal == false || !SpellManager.CanCast(SB.spellPrismCrystal)))) return true;

            //arcane_blast,if=buff.arcane_charge.stack=4&mana.pct>93
            if (await S.spellCast(SB.spellArcaneBlast, U.stacksArcaneCharge == 4 && Me.ManaPercent > 93)) return true;

            //arcane_barrage,if=talent.arcane_orb.enabled&active_enemies>=3&buff.arcane_charge.stack=4&(cooldown.arcane_orb.remains<gcd|prev_gcd.arcane_orb)
            if (await S.spellCast(SB.spellArcaneBarrage, TM.arcaneOrb == true && !Me.HasAura(SB.spellIceFloes) && U.activeCount >= 3 && U.stacksArcaneCharge == 4 && (S.cooldownTimeLeft(SB.spellArcaneOrb) < 2000 || S.lastSpellCast == SB.spellArcaneOrb))) return true;

            //arcane_missiles,if=buff.arcane_charge.stack=4&(!talent.overpowered.enabled|cooldown.arcane_power.remains>10*spell_haste)
            if (await S.spellCast(SB.spellArcaneMissile, U.stacksArcaneCharge == 4 && (TM.overpowered == false || S.cooldownTimeLeft(SB.spellArcanePower) > 10000 * Me.HasteModifier))) return true;

            //supernova,if=mana.pct<96&(buff.arcane_missiles.stack<2|buff.arcane_charge.stack=4)&(buff.arcane_power.up|(charges=1&cooldown.arcane_power.remains>recharge_time))&(!talent.prismatic_crystal.enabled|current_target=prismatic_crystal|(charges=1&cooldown.prismatic_crystal.remains>recharge_time+8))
            if (await S.spellCast(SB.spellSupernova, TM.supernova == true && !Me.HasAura(SB.spellIceFloes) && Me.ManaPercent > 96 && (U.stacksArcaneMissile < 2 || U.stacksArcaneCharge == 4) && (Me.HasAura(SB.spellArcanePower) || (S.spellCharges(SB.spellSupernova) == 1 && S.cooldownTimeLeft(SB.spellArcanePower) > 25000)) && (TM.prismaticCrystal == false || currentTarget.Name == "Prismatic Crystal" || S.spellCharges(SB.spellSupernova) == 1 && S.cooldownTimeLeft(SB.spellPrismCrystal) > 33000))) return true;

            //nether_tempest,cycle_targets=1,if=target!=prismatic_crystal&buff.arcane_charge.stack=4&(active_dot.nether_tempest=0|(ticking&remains<(10-3*talent.arcane_orb.enabled)*spell_haste))
            if (await S.spellCast(SB.spellNetherTempest, TM.netherTempest == true && !Me.HasAura(SB.spellIceFloes) && U.stacksArcaneCharge == 4 && (!currentTarget.HasAura(SB.spellNetherTempest) || U.auraTimeLeft(currentTarget, SB.spellNetherTempest) < (10 - 3 * Me.HasteModifier)))) return true;

            //arcane_barrage,if=buff.arcane_charge.stack=4
            if (await S.spellCast(SB.spellArcaneBarrage, !Me.HasAura(SB.spellIceFloes) && U.stacksArcaneCharge == 4)) return true;

            //presence_of_mind,if=buff.arcane_charge.stack<2&(!talent.prismatic_crystal.enabled|!cooldown.prismatic_crystal.up)
            if (await S.Buff(SB.spellPOM, U.stacksArcaneCharge < 2 && (TM.prismaticCrystal == false || !SpellManager.CanCast(SB.spellPrismCrystal)))) return true;

            //arcane_blast
            if (await S.spellCast(SB.spellArcaneBlast, true)) return true;

            return true;
        }
        #endregion
    }
}
