﻿#region Usings
    using System.Threading.Tasks;
    using System;

    using Styx.CommonBot.Coroutines;
    using Styx;
    using Styx.CommonBot;
    using Styx.WoWInternals.WoWObjects;
#endregion

#region Bindings
    using SB = Arcanum.Core.Helpers.Spell_Book;
    using TM = Arcanum.Core.Managers.Talent_Manager;
    using S = Arcanum.Core.Spell;
    using U = Arcanum.Core.Unit;
    using HKM = Arcanum.Core.Managers.Hotkey_Manager;
    using B = Arcanum.Rotation.Arcane.Burn;
    using C = Arcanum.Rotation.Arcane.Conserve;
    using D = Arcanum.Core.Helpers.Debug;
#endregion

namespace Arcanum.Rotation.Frost
{
    class Rotation
    {
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }


        #region Precombat Buffing - Buffs out of Combat
        public static async Task<bool> preCombatBuffing()
        {
            try
            {
                if (Me.Combat || !Me.IsAlive || (Me.Mounted || Me.OnTaxi))
                {
                    return true;
                }
                return await S.Buff(SB.spellArcBrilliance, (S.needBrilliance() || !Me.HasAura(SB.spellArcBrilliance)));
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in frostPreCombatBuffing: " + error);
                return true;
            }
        }
        #endregion

        #region Combat Buffing - Buffs to use in combat
            public static async Task<bool> combatBuffing()
            {
                try
                {
                    if (!Me.IsAlive || !Me.GotTarget || !currentTarget.IsAlive || !Me.Combat || (Me.Mounted && !Me.HasAura(165803)) || Me.OnTaxi)
                        return true;

                    if (await S.spellDropRoPOnMe(SB.spellRuneofPower, TM.runeOfPower == true && (currentTarget.IsBoss || Me.IsInMyRaid))) return true;

                    if (await S.Buff(SB.spellGreaterInvis, TM.greaterInvisibility == true && currentTarget.IsBoss && Me.Aggro && currentTarget.IsWithinMeleeRange && Me.HealthPercent <= 30)) return true;
                    if (await S.Buff(SB.spellEvanesce, TM.evanesce == true && (Me.Aggro && Me.HealthPercent <= 80))) return true;
                    if (await S.Buff(SB.spellIceBarrier, TM.iceBarrier == true && (Me.HealthPercent <= 50 && !Me.HasAura(SB.spellIceBarrier)))) return true;
                    if (await S.Buff(SB.spellAlterTime, TM.alterTime == true && SpellManager.CanCast(SB.spellAlterTime) && Me.HealthPercent <= 90)) return true;
                    if (await S.Buff(SB.spellAlterTime, TM.alterTime == true && (Me.HasAura(SB.auraAlterTime) && !Me.Combat && Me.HealthPercent <= 90))) return true;
                    if (await S.Buff(SB.spellAlterTime, TM.alterTime == true && (Me.HasAura(SB.auraAlterTime) && Me.HealthPercent <= 30))) return true;
                    if (await S.Buff(SB.spellMirrorImage, TM.mirrorImage == true)) return true;
                    if (await S.Buff(SB.spellColdSnap, TM.coldSnap == true && Me.HealthPercent < 30)) return true;
                    if (await S.Buff(SB.spellIcyVeins, true)) return true;

                    if (await S.usePotion(SB.flaskGreaterDraenicIntellect, !Me.HasAura(SB.flaskGreaterDraenicIntellect) && Me.Combat && Me.IsInMyRaid && Me.IsInInstance)) return true;
                    if (await S.usePotion(SB.potAlchDraenicIntellect, Me.HasAura(SB.spellIcyVeins) && (currentTarget.IsBoss && currentTarget.HealthPercent <= 95 || currentTarget.SafeName == "Prismatic Crystal"))) return true;
                    if (await S.usePotion(SB.potDraenicIntellect, Me.HasAura(SB.spellIcyVeins) && (currentTarget.IsBoss && currentTarget.HealthPercent <= 95 || currentTarget.SafeName == "Prismatic Crystal"))) return true;
                    if (await S.usePotion(SB.healthstone, Me.HealthPercent <= 30)) return true;
                    if (await S.Buff(SB.spellIceFloes, TM.iceFloes == true && Me.IsMoving && !Me.HasAura(SB.spellIceFloes))) return true;
                    return false;
                }
                catch (Exception error)
                {
                    D.diagnosticLog("Exception trown in frostCombatBuffing: " + error);
                    return true;
                }
            }
        #endregion

        #region Rotation Selector - Single or AOE
            public static async Task<bool> rotationSelector()
            {
                try
                {
                    if (!Me.IsAlive || !Me.GotTarget || !currentTarget.IsAlive || (Me.Mounted && !Me.HasAura(165803)) || Me.OnTaxi)
                    {
                        return true;
                    }

                    if (U.activeCountAoE >= 5 && !currentTarget.IsBoss)
                    {
                        return await Frost.AOE.DoAoE();
                    }

                    if (currentTarget.IsBoss && (currentTarget.HealthPercent <= 99 && currentTarget.HealthPercent >= 4 || currentTarget.Name == "Raider's Training Dummy") && TM.prismaticCrystal == true && SpellManager.CanCast(SB.spellPrismCrystal))
                    {
                        if (currentTarget.SafeName == "Kromog")
                        {
                            return true;
                        }
                        if (currentTarget.SafeName == "Blackhand" && currentTarget.HealthPercent <= 20)
                        {
                            return true;
                        }
                        else
                            if (!Me.HasAura(SB.auraRuneOfPower))
                            {
                                if (await S.spellDropRoPOnMe(SB.spellRuneofPower, true)) return true;
                            }
                            return await S.spellDrop(SB.spellPrismCrystal, Me.HasAura(SB.auraRuneOfPower));
                    }

                        return await Frost.SingleTarget.nukeTarget();
                }
                catch (Exception error)
                {
                    D.diagnosticLog("Exception trown in frostRotationSelector: " + error);
                    return true;
                }
            }
            #endregion
    }
}
