﻿#region Usings
    using System.Threading.Tasks;

    using Styx;
    using Styx.CommonBot;
    using Styx.CommonBot.Coroutines;
    using Styx.WoWInternals.WoWObjects;
#endregion

#region Bindings
    using S = Arcanum.Core.Spell;
    using SB = Arcanum.Core.Helpers.Spell_Book;
    using U = Arcanum.Core.Unit;
    using TM = Arcanum.Core.Managers.Talent_Manager;
#endregion

namespace Arcanum.Rotation.Frost
{
    class SingleTarget
    {
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        #region Single Rotation

        public static async Task<bool> nukeTarget()
        {
            if (SpellManager.CanCast(SB.spellCounterspell) && currentTarget.CanInterruptCurrentSpellCast && (currentTarget.IsCasting || currentTarget.IsChanneling))
            {
                await CommonCoroutines.SleepForRandomReactionTime();
                return await S.spellCast(SB.spellCounterspell, currentTarget.CanInterruptCurrentSpellCast);
            }

            if (TM.frostjaw == true && !SpellManager.CanCast(SB.spellCounterspell) && currentTarget.Distance <= 30 && currentTarget.CanInterruptCurrentSpellCast && (currentTarget.IsCasting || currentTarget.IsChanneling))
            {
                await CommonCoroutines.SleepForRandomReactionTime();
                return await S.spellCast(SB.spellFrostjaw, TM.frostjaw == true && currentTarget.CanInterruptCurrentSpellCast);
            }

            if (await S.spellDrop(SB.spellRingofFrost, TM.ringOfFrost == true && (U.activeCount >= 3 && currentTarget.Distance <= 30))) return true;
            if (await S.spellCast(SB.spellIceLance, S.lastSpellCast == SB.spellDeepFreeze && U.stacksFingerFrost >= 1)) return true;
            if (await S.spellCast(SB.spellFrozenOrb, true)) return true;
            if (await S.spellCast(SB.spellIceLance, S.cooldownTimeLeft(SB.spellFrozenOrb) >= 50000 && U.stacksFingerFrost >= 1)) return true;
            if (await S.spellCast(SB.spellFrostfireBolt, U.stacksBrainFreeze >= 1)) return true;
            if (await S.spellCast(SB.spellIceNova, TM.iceNova == true && S.spellCharges(SB.spellIceNova) == 2)) return true;
            if (await S.spellCast(SB.spellIceNova, TM.iceNova == true && Me.HasAura(SB.spellIcyVeins))) return true;
            if (await S.spellCast(SB.spellCometStorm, TM.cometStorm == true)) return true;
            if (await S.spellCast(SB.spellIceLance, S.cooldownTimeLeft(SB.spellFrozenOrb) >= 10000 && U.stacksFingerFrost == 2)) return true;
            if (await S.spellCast(SB.spellDeepFreeze, !currentTarget.IsBoss)) return true;
            if (await S.spellCast(SB.spellFrostbolt, true)) return true;

            return true;
        }
        #endregion
    }
}
