﻿#region Usings
    using System.Threading.Tasks;
    using System;

    using Styx.CommonBot.Coroutines;
    using Styx;
    using Styx.CommonBot;
    using Styx.WoWInternals.WoWObjects;
#endregion

#region Bindings
    using SB = Arcanum.Core.Helpers.Spell_Book;
    using TM = Arcanum.Core.Managers.Talent_Manager;
    using S = Arcanum.Core.Spell;
    using U = Arcanum.Core.Unit;
    using HKM = Arcanum.Core.Managers.Hotkey_Manager;
    using B = Arcanum.Rotation.Arcane.Burn;
    using C = Arcanum.Rotation.Arcane.Conserve;
    using D = Arcanum.Core.Helpers.Debug;
#endregion

namespace Arcanum.Rotation
{
    class Rotation
    {
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }


        #region Precombat Buffing - Buffs out of Combat
        public static async Task<bool> preCombatBuffing()
        {
            try
            {
                if (Me.Combat || !Me.IsAlive || (Me.Mounted || Me.OnTaxi))
                {
                    return true;
                }
                if (Me.Specialization == WoWSpec.MageArcane)
                {
                    return await Arcane.Rotation.preCombatBuffing();
                }
                if (Me.Specialization == WoWSpec.MageFrost)
                {
                    return await Frost.Rotation.preCombatBuffing();
                }
                //if (Me.Specialization == WoWSpec.MageFire)
                //{
                //    return await Fire.Rotation.preCombatBuffing();
                //}
                return true;
            }
            catch (Exception error)
            {
                D.diagnosticLog("Exception trown in mainPreCombatBuffing: " + error);
                return true;
            }
        }
        #endregion

        #region Combat Buffing - Buffs to use in combat
            public static async Task<bool> combatBuffing()
            {
                try
                {
                    if (!Me.IsAlive || !Me.GotTarget || !currentTarget.IsAlive || !Me.Combat || (Me.Mounted && !Me.HasAura(165803)) || Me.OnTaxi)
                    {
                        return true;
                    }
                    if (Me.Specialization == WoWSpec.MageArcane)
                    {
                        return await Arcane.Rotation.combatBuffing();
                    }
                    if (Me.Specialization == WoWSpec.MageFrost)
                    {
                        return await Frost.Rotation.combatBuffing();
                    }
                    //if (Me.Specialization == WoWSpec.MageFire)
                    //{
                    //    return await Fire.Rotation.combatBuffing();
                    //}
                    return true;
                }
                catch (Exception error)
                {
                    D.diagnosticLog("Exception trown in mainCombatBuffing: " + error);
                    return true;
                }
            }
        #endregion

        #region Rotation Selector - Single or AOE
            public static async Task<bool> rotationSelector()
            {
                try
                {
                    if (!Me.IsAlive || !Me.GotTarget || !currentTarget.IsAlive || (Me.Mounted && !Me.HasAura(165803)) || Me.OnTaxi)
                    {
                        return true;
                    }
                    if (Me.Specialization == WoWSpec.MageArcane)
                    {
                        return await Arcane.Rotation.rotationSelector();
                    }
                    if (Me.Specialization == WoWSpec.MageFrost)
                    {
                        return await Frost.Rotation.rotationSelector();
                    }
                    //if (Me.Specialization == WoWSpec.MageFire)
                    //{
                    //    return await Fire.Rotation.rotationSelector();
                    //}
                    return true;
                }
                catch (Exception error)
                {
                    D.diagnosticLog("Exception trown in mainRotationSelector: " + error);
                    return true;
                }
            }
            #endregion
    }
}
